// Code generated by ent, DO NOT EDIT.

package statement

import (
	"entgo.io/ent/dialect/sql"
	"entgo.io/ent/dialect/sql/sqlgraph"
	"github.com/testifysec/archivista/ent/predicate"
)

// ID filters vertices based on their ID field.
func ID(id int) predicate.Statement {
	return predicate.Statement(func(s *sql.Selector) {
		s.Where(sql.EQ(s.C(FieldID), id))
	})
}

// IDEQ applies the EQ predicate on the ID field.
func IDEQ(id int) predicate.Statement {
	return predicate.Statement(func(s *sql.Selector) {
		s.Where(sql.EQ(s.C(FieldID), id))
	})
}

// IDNEQ applies the NEQ predicate on the ID field.
func IDNEQ(id int) predicate.Statement {
	return predicate.Statement(func(s *sql.Selector) {
		s.Where(sql.NEQ(s.C(FieldID), id))
	})
}

// IDIn applies the In predicate on the ID field.
func IDIn(ids ...int) predicate.Statement {
	return predicate.Statement(func(s *sql.Selector) {
		v := make([]any, len(ids))
		for i := range v {
			v[i] = ids[i]
		}
		s.Where(sql.In(s.C(FieldID), v...))
	})
}

// IDNotIn applies the NotIn predicate on the ID field.
func IDNotIn(ids ...int) predicate.Statement {
	return predicate.Statement(func(s *sql.Selector) {
		v := make([]any, len(ids))
		for i := range v {
			v[i] = ids[i]
		}
		s.Where(sql.NotIn(s.C(FieldID), v...))
	})
}

// IDGT applies the GT predicate on the ID field.
func IDGT(id int) predicate.Statement {
	return predicate.Statement(func(s *sql.Selector) {
		s.Where(sql.GT(s.C(FieldID), id))
	})
}

// IDGTE applies the GTE predicate on the ID field.
func IDGTE(id int) predicate.Statement {
	return predicate.Statement(func(s *sql.Selector) {
		s.Where(sql.GTE(s.C(FieldID), id))
	})
}

// IDLT applies the LT predicate on the ID field.
func IDLT(id int) predicate.Statement {
	return predicate.Statement(func(s *sql.Selector) {
		s.Where(sql.LT(s.C(FieldID), id))
	})
}

// IDLTE applies the LTE predicate on the ID field.
func IDLTE(id int) predicate.Statement {
	return predicate.Statement(func(s *sql.Selector) {
		s.Where(sql.LTE(s.C(FieldID), id))
	})
}

// Predicate applies equality check predicate on the "predicate" field. It's identical to PredicateEQ.
func Predicate(v string) predicate.Statement {
	return predicate.Statement(func(s *sql.Selector) {
		s.Where(sql.EQ(s.C(FieldPredicate), v))
	})
}

// PredicateEQ applies the EQ predicate on the "predicate" field.
func PredicateEQ(v string) predicate.Statement {
	return predicate.Statement(func(s *sql.Selector) {
		s.Where(sql.EQ(s.C(FieldPredicate), v))
	})
}

// PredicateNEQ applies the NEQ predicate on the "predicate" field.
func PredicateNEQ(v string) predicate.Statement {
	return predicate.Statement(func(s *sql.Selector) {
		s.Where(sql.NEQ(s.C(FieldPredicate), v))
	})
}

// PredicateIn applies the In predicate on the "predicate" field.
func PredicateIn(vs ...string) predicate.Statement {
	v := make([]any, len(vs))
	for i := range v {
		v[i] = vs[i]
	}
	return predicate.Statement(func(s *sql.Selector) {
		s.Where(sql.In(s.C(FieldPredicate), v...))
	})
}

// PredicateNotIn applies the NotIn predicate on the "predicate" field.
func PredicateNotIn(vs ...string) predicate.Statement {
	v := make([]any, len(vs))
	for i := range v {
		v[i] = vs[i]
	}
	return predicate.Statement(func(s *sql.Selector) {
		s.Where(sql.NotIn(s.C(FieldPredicate), v...))
	})
}

// PredicateGT applies the GT predicate on the "predicate" field.
func PredicateGT(v string) predicate.Statement {
	return predicate.Statement(func(s *sql.Selector) {
		s.Where(sql.GT(s.C(FieldPredicate), v))
	})
}

// PredicateGTE applies the GTE predicate on the "predicate" field.
func PredicateGTE(v string) predicate.Statement {
	return predicate.Statement(func(s *sql.Selector) {
		s.Where(sql.GTE(s.C(FieldPredicate), v))
	})
}

// PredicateLT applies the LT predicate on the "predicate" field.
func PredicateLT(v string) predicate.Statement {
	return predicate.Statement(func(s *sql.Selector) {
		s.Where(sql.LT(s.C(FieldPredicate), v))
	})
}

// PredicateLTE applies the LTE predicate on the "predicate" field.
func PredicateLTE(v string) predicate.Statement {
	return predicate.Statement(func(s *sql.Selector) {
		s.Where(sql.LTE(s.C(FieldPredicate), v))
	})
}

// PredicateContains applies the Contains predicate on the "predicate" field.
func PredicateContains(v string) predicate.Statement {
	return predicate.Statement(func(s *sql.Selector) {
		s.Where(sql.Contains(s.C(FieldPredicate), v))
	})
}

// PredicateHasPrefix applies the HasPrefix predicate on the "predicate" field.
func PredicateHasPrefix(v string) predicate.Statement {
	return predicate.Statement(func(s *sql.Selector) {
		s.Where(sql.HasPrefix(s.C(FieldPredicate), v))
	})
}

// PredicateHasSuffix applies the HasSuffix predicate on the "predicate" field.
func PredicateHasSuffix(v string) predicate.Statement {
	return predicate.Statement(func(s *sql.Selector) {
		s.Where(sql.HasSuffix(s.C(FieldPredicate), v))
	})
}

// PredicateEqualFold applies the EqualFold predicate on the "predicate" field.
func PredicateEqualFold(v string) predicate.Statement {
	return predicate.Statement(func(s *sql.Selector) {
		s.Where(sql.EqualFold(s.C(FieldPredicate), v))
	})
}

// PredicateContainsFold applies the ContainsFold predicate on the "predicate" field.
func PredicateContainsFold(v string) predicate.Statement {
	return predicate.Statement(func(s *sql.Selector) {
		s.Where(sql.ContainsFold(s.C(FieldPredicate), v))
	})
}

// HasSubjects applies the HasEdge predicate on the "subjects" edge.
func HasSubjects() predicate.Statement {
	return predicate.Statement(func(s *sql.Selector) {
		step := sqlgraph.NewStep(
			sqlgraph.From(Table, FieldID),
			sqlgraph.To(SubjectsTable, FieldID),
			sqlgraph.Edge(sqlgraph.O2M, false, SubjectsTable, SubjectsColumn),
		)
		sqlgraph.HasNeighbors(s, step)
	})
}

// HasSubjectsWith applies the HasEdge predicate on the "subjects" edge with a given conditions (other predicates).
func HasSubjectsWith(preds ...predicate.Subject) predicate.Statement {
	return predicate.Statement(func(s *sql.Selector) {
		step := sqlgraph.NewStep(
			sqlgraph.From(Table, FieldID),
			sqlgraph.To(SubjectsInverseTable, FieldID),
			sqlgraph.Edge(sqlgraph.O2M, false, SubjectsTable, SubjectsColumn),
		)
		sqlgraph.HasNeighborsWith(s, step, func(s *sql.Selector) {
			for _, p := range preds {
				p(s)
			}
		})
	})
}

// HasAttestationCollections applies the HasEdge predicate on the "attestation_collections" edge.
func HasAttestationCollections() predicate.Statement {
	return predicate.Statement(func(s *sql.Selector) {
		step := sqlgraph.NewStep(
			sqlgraph.From(Table, FieldID),
			sqlgraph.To(AttestationCollectionsTable, FieldID),
			sqlgraph.Edge(sqlgraph.O2O, false, AttestationCollectionsTable, AttestationCollectionsColumn),
		)
		sqlgraph.HasNeighbors(s, step)
	})
}

// HasAttestationCollectionsWith applies the HasEdge predicate on the "attestation_collections" edge with a given conditions (other predicates).
func HasAttestationCollectionsWith(preds ...predicate.AttestationCollection) predicate.Statement {
	return predicate.Statement(func(s *sql.Selector) {
		step := sqlgraph.NewStep(
			sqlgraph.From(Table, FieldID),
			sqlgraph.To(AttestationCollectionsInverseTable, FieldID),
			sqlgraph.Edge(sqlgraph.O2O, false, AttestationCollectionsTable, AttestationCollectionsColumn),
		)
		sqlgraph.HasNeighborsWith(s, step, func(s *sql.Selector) {
			for _, p := range preds {
				p(s)
			}
		})
	})
}

// HasDsse applies the HasEdge predicate on the "dsse" edge.
func HasDsse() predicate.Statement {
	return predicate.Statement(func(s *sql.Selector) {
		step := sqlgraph.NewStep(
			sqlgraph.From(Table, FieldID),
			sqlgraph.To(DsseTable, FieldID),
			sqlgraph.Edge(sqlgraph.O2M, true, DsseTable, DsseColumn),
		)
		sqlgraph.HasNeighbors(s, step)
	})
}

// HasDsseWith applies the HasEdge predicate on the "dsse" edge with a given conditions (other predicates).
func HasDsseWith(preds ...predicate.Dsse) predicate.Statement {
	return predicate.Statement(func(s *sql.Selector) {
		step := sqlgraph.NewStep(
			sqlgraph.From(Table, FieldID),
			sqlgraph.To(DsseInverseTable, FieldID),
			sqlgraph.Edge(sqlgraph.O2M, true, DsseTable, DsseColumn),
		)
		sqlgraph.HasNeighborsWith(s, step, func(s *sql.Selector) {
			for _, p := range preds {
				p(s)
			}
		})
	})
}

// And groups predicates with the AND operator between them.
func And(predicates ...predicate.Statement) predicate.Statement {
	return predicate.Statement(func(s *sql.Selector) {
		s1 := s.Clone().SetP(nil)
		for _, p := range predicates {
			p(s1)
		}
		s.Where(s1.P())
	})
}

// Or groups predicates with the OR operator between them.
func Or(predicates ...predicate.Statement) predicate.Statement {
	return predicate.Statement(func(s *sql.Selector) {
		s1 := s.Clone().SetP(nil)
		for i, p := range predicates {
			if i > 0 {
				s1.Or()
			}
			p(s1)
		}
		s.Where(s1.P())
	})
}

// Not applies the not operator on the given predicate.
func Not(p predicate.Statement) predicate.Statement {
	return predicate.Statement(func(s *sql.Selector) {
		p(s.Not())
	})
}
